Ръководство за Java накрая Ключова дума

1. Общ преглед

В този урок ще изследваме ключовата дума накрая в Java. Ще видим как да го използваме заедно с блокове try / catch при обработката на грешки. Въпреки че накрая има за цел да гарантира изпълнението на кода, ще обсъдим изключителни ситуации, в които JVM не го изпълнява.

Ще обсъдим и някои общи подводни камъни, при които окончателният блок може да има неочакван резултат.

2. Какво е най-накрая?

накрая дефинира блок код, който използваме заедно с ключовата дума try . Той дефинира код, който винаги се изпълнява след опита и всеки блок за хващане , преди методът да бъде завършен.

Блокът окончателно се изпълнява, независимо дали е хвърлено или уловено изключение .

2.1. Бърз пример

Нека да разгледаме накрая в блок try-catch- final:

try { System.out.println("The count is " + Integer.parseInt(count)); } catch (NumberFormatException e) { System.out.println("No count"); } finally { System.out.println("In finally"); } 

В този пример, независимо от стойността на броя на параметрите , JVM изпълнява блока окончателно и отпечатва „В крайна сметка“ .

2.2. Използване накрая без блок за улов

Също така, ние можем да използваме по най-накрая да блокира с опит блок независимо дали улов блок присъства :

try { System.out.println("Inside try"); } finally { System.out.println("Inside finally"); }

И ще получим резултата:

Inside try Inside finally

2.3. Защо най-накрая е полезно

Ние обикновено се използва най-накрая блок, за да се изпълни почистване код като затваряне връзки, затваряне на файлове, или освобождаване на конци, тъй като тя се изпълнява независимо от изключение.

Забележка: try-with-resources може да се използва и за затваряне на ресурси вместо окончателен блок.

3. Кога най-накрая се изпълнява

Нека да разгледаме всички пермутации на това, когато JVM изпълнява окончателно блокове, за да можем да го разберем по-добре.

3.1. Не се хвърля изключение

Когато опитам блока приключи, най-накрая блок се изпълнява, дори и да не е имало изключение:

try { System.out.println("Inside try"); } finally { System.out.println("Inside finally"); }

В този пример не изхвърляме изключение от блока try . По този начин JVM изпълнява целия код както в блоковете try, така и накрая .

Това извежда:

Inside try Inside finally

3.2. Изключение се хвърля и не се обработва

Ако има изключение и то не е уловено, блокът окончателно все още се изпълнява:

try { System.out.println("Inside try"); throw new Exception(); } finally { System.out.println("Inside finally"); }

JVM изпълнява окончателния блок дори в случай на необработено изключение.

И изходът ще бъде:

Inside try Inside finally Exception in thread "main" java.lang.Exception

3.3. Изключение се хвърля и обработва

Ако има изключение и то е уловено от блока catch , окончателният блок все още се изпълнява:

try { System.out.println("Inside try"); throw new Exception(); } catch (Exception e) { System.out.println("Inside catch"); } finally { System.out.println("Inside finally"); }

В този случай блокът catch хваща хвърленото изключение и тогава JVM изпълнява блока окончателно и извежда изхода:

Inside try Inside catch Inside finally

3.4. Метод Връща от опит Блокиране

Дори връщането от метода няма да попречи на накрая да стартират блокове:

try { System.out.println("Inside try"); return "from try"; } finally { System.out.println("Inside finally"); }

Тук, въпреки че методът има оператор return , JVM изпълнява блока окончателно, преди да предаде контролата на извикващия метод.

Ще получим изхода:

Inside try Inside finally

3.5. Метод Връща от блока catch

When the catch block contains a return statement, the finally block is still called:

try { System.out.println("Inside try"); throw new Exception(); } catch (Exception e) { System.out.println("Inside catch"); return "from catch"; } finally { System.out.println("Inside finally"); }

When we throw an exception from the try block, the catch block handles the exception. Though there is a return statement in the catch block, the JVM executes the finally block before handing control over to the calling method, and it outputs:

Inside try Inside catch Inside finally

4. When finally Isn’t Executed

Although we always expect the JVM to execute the statements inside a finally block, there are some situations where the JVM will not execute a finally block.

We might already expect that if the operating system stops our program, then the program would not get the chance to execute all of its code. There are also some actions we can take that will similarly prevent the execution of a pending finally block.

4.1. Invoking System.exit

In this case, we are terminating the JVM by calling System.exit and hence the JVM will not execute our finally block:

try { System.out.println("Inside try"); System.exit(1); } finally { System.out.println("Inside finally"); }

This outputs:

Inside try

4.2. Invoking halt

Similar to System.exit, a call to Runtime.halt also halts the execution and the JVM does not execute any finally blocks:

try { System.out.println("Inside try"); Runtime.getRuntime().halt(1); } finally { System.out.println("Inside finally"); }

Thus, the output will be:

Inside try

4.3. Daemon Thread

If a Daemon thread enters the execution of a try/finally block and all other non-daemon threads exit before the daemon thread executes the finally block, the JVM doesn’t wait for the daemon thread to finish the execution of finally block:

Runnable runnable = () -> { try { System.out.println("Inside try"); } finally { try { Thread.sleep(1000); System.out.println("Inside finally"); } catch (InterruptedException e) { e.printStackTrace(); } } }; Thread regular = new Thread(runnable); Thread daemon = new Thread(runnable); daemon.setDaemon(true); regular.start(); Thread.sleep(300); daemon.start();

In this example, the runnable prints “Inside try” as soon as it enters the method and waits for 1 second before printing “Inside finally”.

Here, we start the regular thread and the daemon thread with a small delay. When the regular thread executes the finally block, the daemon thread is still waiting within the try block. As the regular thread completes execution and exits, the JVM also exits and does not wait for the daemon thread to complete the finally block.

Here's the output:

Inside try Inside try Inside finally

4.4. JVM Reaches an Infinite Loop

Here's a try block which contains an infinite while loop:

try { System.out.println("Inside try"); while (true) { } } finally { System.out.println("Inside finally"); }

Though it's not specific to finally, it's worth mentioning that if the try or catch block contains an infinite loop, the JVM will never reach any block beyond that loop.

5. Common Pitfalls

There are some common pitfalls that we must avoid when we use the finally block.

Although it's perfectly legal, it's considered bad practice to have a return statement or throw an exception from a finally block, and we should avoid it at all costs.

5.1. Disregards Exception

A return statement in the finally block ignores an uncaught exception:

try { System.out.println("Inside try"); throw new RuntimeException(); } finally { System.out.println("Inside finally"); return "from finally"; }

In this case, the method ignores the RuntimeException thrown and returns the value “from finally”.

5.2. Ignores Other return Statements

A return statement in the finally block ignores any other return statement in the try or catch block. Only the return statement in the finally block executes:

try { System.out.println("Inside try"); return "from try"; } finally { System.out.println("Inside finally"); return "from finally"; }

In this example, the method always returns “from finally” and completely ignores the return statement in the try block. This could be a very difficult bug to spot, which is why we should avoid using return in finally blocks.

5.3. Changes What's Thrown or Returned

Also, in the case of throwing an exception from a finally block, the method disregards the exception thrown or return statements in the try and catch blocks:

try { System.out.println("Inside try"); return "from try"; } finally { throw new RuntimeException(); }

This method never returns a value and always throws a RuntimeException.

Въпреки че не можем умишлено да хвърлим изключение от блока окончателно, както в този пример, все пак може да срещнем този проблем. Това може да се случи, когато методите за почистване, които използваме в окончателен блок, хвърлят изключение.

6. Заключение

В тази статия обсъдихме какво най-накрая правят блоковете в Java и как да ги използваме. След това разгледахме различни случаи, когато JVM ги изпълнява, и няколко, когато това може да не стане.

И накрая, разгледахме някои често срещани клопки, свързани с използването на окончателно блокове.

Както винаги, изходният код, използван в този урок, е достъпен в GitHub.